#include <stdio.h>
#include <stdlib.h>
#include "pvm3.h"
#include "readvectors.h"


int main(int argc, char *argv[])
{
	char *filename;
	int numproc;
	
	int length, numread;
	int *arr1,*arr2;
	int *tids;

	int i,cc,start,sublength;
	int result=0, res;

	printf("test");	
	if (argc != 3) {
		printf("Usage: prog filename numproc\n");
		return 1;
	}

	filename = argv[1];
	numproc = atoi(argv[2]);
	arr1 = malloc(sizeof(int)*10);
	arr2 = malloc(sizeof(int)*10);
	length = 10;
	readvectors(filename, &arr1, &arr2, &length, &numread);
	
/*	printf("\n%s %i\n",filename,numproc);
	for ( i=0; i < numread; i++) {
		printf("%i ",arr[i]);
		}	*/
	

	tids = malloc(sizeof(int)*numproc);
	cc = pvm_spawn("pa2/pvm_calc", (char**)0, 0, "", numproc, tids);
	printf("%i\n",cc);
	if (cc == numproc) {
		for (i=0; i < numproc;i++) {
			pvm_initsend(PvmDataDefault);
			start = numread/numproc*i;
			sublength = numread/numproc;
			if (i == numproc - 1 )
				sublength += numread % numproc;
			printf("%i %i\n",start,sublength);
			pvm_pkint(&sublength,1,1);
			pvm_pkint(&arr1[start],sublength,1);
			pvm_pkint(&arr2[start],sublength,1);
			pvm_pkint(&numproc,1,1);
			pvm_pkint(tids,numproc,1);
			pvm_send(tids[i],1);
		}

		pvm_recv(tids[0],-1);
		pvm_upkint(&res,1,1);
		result= res;
		printf("Result is %i\n",result);
		
	}  else printf("can't start pvm_calc\n");

	pvm_exit();

	exit(0);
}
